using System.Xml;
using System.Xml.Serialization;
using System.Messaging;
using System.Text;
using System;
using System.Web.Services;

[WebService(Namespace = "http://cronus.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class GetNavisionData : System.Web.Services.WebService 
{
	[WebMethod]
	public XmlElement GetCustomers(string CompanyName, string FunctionName, string ParameterList) 
	{
		System.Configuration.AppSettingsSection app = new System.Configuration.AppSettingsSection();
		string queueFromNavision = String.Format(@".\private$\{0} 2", CompanyName);
		string queueToNavision = String.Format(@".\private$\{0} 1", CompanyName);
		NavisionObject navisionObject1 = new NavisionObject();
		NavisionObject navisionObject2 = new NavisionObject();
		NavisionErrorMsg navisionErrorMsg = new NavisionErrorMsg();
		MessageQueue queue1 = new MessageQueue(queueToNavision);
		MessageQueue queue2 = new MessageQueue(queueFromNavision);
		Message message1 = new Message();
		Message message2 = new Message();
		XmlDocument xmlDocument = new XmlDocument();
		XmlElement xmlElement1;
		XmlElement xmlElement2;
		XmlMessageFormatter formatter1 = new XmlMessageFormatter(new Type[] { typeof(NavisionErrorMsg) });
		if (!MessageQueue.Exists(queueFromNavision))
		{
			queue2 = MessageQueue.Create(queueFromNavision);
			queue2.Label = queueFromNavision;
			queue2.Authenticate = false;
			queue2.MessageReadPropertyFilter.CorrelationId = true;
			queue2.UseJournalQueue = true;
		}
		if (!MessageQueue.Exists(queueToNavision))
		{
			queue1 = MessageQueue.Create(queueToNavision);
			queue1.Label = queueToNavision;
			queue1.Authenticate = false;
			queue1.UseJournalQueue = true;
		}
		navisionObject1.UserName = this.User.Identity.Name;
		navisionObject1.CompanyName = CompanyName;
		navisionObject1.FunctionName = FunctionName;
		navisionObject1.ParameterList = ParameterList;
		navisionObject1.Result = "";
		message1 = new Message(navisionObject1);
		message1.Label = "Navision MSMQ-BA";
		message1.ResponseQueue = queue2;
		queue1.Send(message1);
		xmlDocument = new XmlDocument();
		xmlElement1 = xmlDocument.CreateElement("error", "description", "urn:errors");
		try
		{
			message2 = queue2.PeekByCorrelationId(message1.Id, new TimeSpan(0, 1, 0));
		}
		catch (Exception ex)
		{
			xmlElement1.InnerText = ex.Message;
			return xmlElement1;
		}
		if (formatter1.CanRead(message2))
		{
			message2 = queue2.ReceiveById(message2.Id);
			message2.Formatter = new XmlMessageFormatter(new Type[] { typeof(NavisionErrorMsg) });
			navisionErrorMsg = (NavisionErrorMsg)message2.Body;
			xmlElement1.InnerText = navisionErrorMsg.ErrorMessage;
			return xmlElement1;
		}
		else
		{
			message2 = queue2.ReceiveById(message2.Id);
			message2.Formatter = new XmlMessageFormatter(new Type[] { typeof(XmlElement) });
			xmlElement2 = (XmlElement)message2.Body;
			return xmlElement2;
		}
	}
}

